#include <bits/stdc++.h>

using namespace std;

const int maxn = 200500;

vector < vector < int > > g(maxn);
int dr[maxn], dv[maxn];

void dfs1(int v, int p) {
    for (auto u : g[v]) {
        if (p != u) {
            dr[u] = dr[v] + 1;
            dfs1(u, v);
        }
    }

}

void dfs2(int v, int p) {
    for (auto u : g[v]) {
        if (p != u) {
            dv[u] = dv[v] + 1;
            dfs2(u, v);
        }
    }

}

int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[i].push_back(p);
        g[p].push_back(i);
    }
    dfs1(0, -1);
    int v1 = -1;
    for (int i = 1; i < n; i++) {
        if (v1 == -1 || dr[i] > dr[v1]) {
            v1 = i;
        }
    }
    dfs2(v1, -1);
    int v2 = -1;
    for (int i = 0; i < n; i++) {
        if (v2 == -1 || dv[i] > dv[v2]) {
            v2 = i;
        }
    }
    cout << dv[v2] + 1;
    return 0;
}
